" Quelques raccourcis utiles pour diter un fichier HTML

command! FF !firefox % &

let b:nextstop_leftright = '<'
let b:nextstop_updown = '<[^/]'

runtime macros/nextstop.vim

if exists("html_additions_loaded")
	delfunction Vsel
	delfunction HTML_AddTag
	delfunction HTML_DelTag
endif

noremap <buffer> <silent> <Leader>i :<C-U>call Vsel()<CR>
noremap <buffer> <silent> <Leader>v :<C-U>call Vsel()<CR>

let s:closed_tags = '\%(<meta[^>]*>\|<br>\)\@!<\([^/>][^\s>]*\)[^>]*>'

function Vsel() range
	let reg_save = @@
	let save_whichwrap = &whichwrap
	let &whichwrap = "h,l"

	let startline = line(".")
	let startcol = col(".")
	let move_done = 0
	if search(s:closed_tags, 'Wbc')
		silent exe "normal! l"
		" call setpos("'s", getpos("."))
		if search('>\|\s', 'Ws')
			silent exe "normal! y`'"
			if search('>', 'Wc')
				silent exe "normal! lv"
				if search('</' . @@ . '>', 'W')
					silent exe "normal! ho"
					let move_done = 1
				endif
			endif
		endif
	endif
	if !move_done
		call cursor(startline, startcol)
		silent exe "normal! \<Esc>"
	endif
	let &whichwrap = save_whichwrap
	let @@ = reg_save
endfunction

vnoremap <buffer> <silent> <Leader>b :<C-U>call HTML_AddTag('b')<CR>
vnoremap <buffer> <silent> <Leader>c :<C-U>call HTML_AddTag('code')<CR>
vnoremap <buffer> <silent> <Leader>e :<C-U>call HTML_AddTag('em')<CR>

function HTML_AddTag(t) range
	let reg_save = @@

	let shift = strlen(a:t) + 3
	silent exe "normal! gvc<" . a:t . ">\<C-R>\"</" . a:t . ">\<Esc>" . shift . "h"

	let @@ = reg_save
endfunction

vnoremap <buffer> <Leader>d :<C-U>call HTML_DelTag()<CR>

function HTML_DelTag() range
	" let reg_save = @@
	let save_whichwrap = &whichwrap
	let &whichwrap = "h,l"

	  " Any text is good here, I wrote something that is unlikely to collide
	  " with another text, should such text be placed in the document.
	  " It's gruiiiik? Yes it is.
	let x = '::::HTML_DelTag-Start-' . strftime("%Y%m%d%H%M%S") . '-HTML_DelTag-End::::'
	let e = s:closed_tags . '\_s*' . x . '\_s*' . '</\1>'
	execute "normal! gvc" . x . "\<Esc>"
	if search(e, 'Wb')
		if search(e, 'Wse')
			execute "normal! v`'\"_dP"
		endif
	endif

	let &whichwrap = save_whichwrap
	" let @@ = reg_save
endfunction

let html_additions_loaded=1
