" syntax/adfind.vim

" Sbastien Millet, Juillet 2009
" 15/07/2009

" Fichier de surbrillance syntaxique pour le type adfind

if version < 600
	syntax clear
elseif exists("b:current_syntax")
	finish
endif

syntax clear
syntax case ignore

syntax match adfindDN /^dn:.*/
syntax match adfindADItems /^>\(displayname\|samaccountname\|cn\):.*/ contains=adfindHighlightADValues
syntax match adfindExchItems /^>\(proxyaddresses\|msexch.*\|mail\):.*/ contains=adfindHighlightExchValues
syntax match adfindMemberofItems /^>memberof:.*/ contains=adfindMemberofValues
syntax match adfindRiotintoStringsItems /^>riotintostring[0-9]\+:.*/ contains=adfindRiotintoStringsValues
syntax match adfindHighlightADValues /:\s*\zs.*/ contained
syntax match adfindHighlightExchValues /:\s*\zs.*/ contained
syntax match adfindMemberofValues /:\s*\zs.*/ contained
syntax match adfindRiotintoStringsValues /:\s*\zs.*/ contained

hi def link adfindDN Error
hi adfindHighlightADValues guibg=lightgrey ctermbg=lightgrey
hi adfindHighlightExchValues guibg=yellow ctermbg=yellow
hi def link adfindMemberofValues Comment
hi def link adfindRiotintoStringsValues Type

let b:current_syntax = "adfind"
