" syntax/rh.vim

" Sbastien Millet, Juin 2009
" 23/06/09

" Fichier de surbrillance syntaxique pour les en-ttes d'un email, en
" particulier les champs Received

if version < 600
	syntax clear
elseif exists("b:current_syntax")
	finish
endif

" Dcommenter pour afficher les ',' autrement, mais attention aux performances
" let b:highlight_commas=1

syntax clear
syntax case ignore

syntax region rhHeaderOther start=/^\S/ skip=/^\s/ end=/^\S/me=s-1
	\ contains=rhHeaderOtherNameNonStd,rhHeaderOtherNameStd,rhEmailAddress
syntax match rhHeaderOtherNameNonStd /^[^:]*:/ contained
syntax match rhHeaderOtherNameStd /^\(from\|to\|cc\|sender\|reply-to\|message-id\|return-path\|mime-version\|user-agent\|content-type\|content-transfer-encoding\|status\|date\)\s*:/ contained
syntax region rhHeaderSubject start=/^subject\s*:/ skip=/^\s/ end=/^\S/me=s-1 contains=rhHeaderSubjectName,rhHeaderSubjectValue
syntax match rhHeaderSubjectName /^subject\s*:/ nextgroup=rhHeaderSubjectValue contained
syntax match rhHeaderSubjectValue /:\@<=\s*\zs\(.\|\n\s\)*/ contained
syntax region rhHeaderReceived start=/^received\s*:/ skip=/^\s/ end=/^\S/me=s-1 contains=rhHeaderReceivedName,rhHeaderReceivedValue
syntax match rhHeaderReceivedName /^received\s*:/ nextgroup=rhHeaderReceivedValue contained
syntax match rhHeaderReceivedValue /:\@<=\s*\zs\(.\|\n\s\)*/ contained
	\ contains=rhHeaderReceivedValueS1,rhHeaderReceivedValueS2,rhHeaderReceivedValueS3
syntax match rhHeaderReceivedValueS1 /\(from\(\s\|\n\s\)\+\)\@<=\S\+/ nextgroup=rhHeaderReceivedValueS2 contained
syntax match rhHeaderReceivedValueS2 /\(by\(\s\|\n\s\)\+\)\@<=\S\+/ nextgroup=rhHeaderReceivedValueS3 contained
syntax match rhHeaderReceivedValueS3 /\s\+\zs[0-9]\{1,2\}:[0-9]\{1,2}:[0-9]\{1,2}\s\+[-+]\?[0-9]\{4}/ contained
syntax match rhEmailAddress /<\?[^ \t@<>]\+@[^ \t@<>]\+>\?/ contained

syntax sync fromstart

hi def link rhHeaderOther Normal
hi def link rhHeaderOtherNameStd Type
hi def link rhHeaderOtherNameNonStd Identifier
hi def link rhHeaderSubjectName Type
hi def link rhHeaderSubjectValue WarningMsg
hi def link rhHeaderReceivedName Underlined
hi def link rhEmailAddress Special
  " Not a good practice to define colors directly, but I didn't find the ones
  " I needed in the actual set.
hi rhHeaderReceivedValueS1 guibg=lightgrey ctermbg=lightgrey
hi rhHeaderReceivedValueS2 guibg=yellow ctermbg=yellow
hi rhHeaderReceivedValueS3 guibg=darkblue guifg=white ctermbg=darkblue ctermfg=white

let b:current_syntax = "rh"
